diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/civclient.c freeciv-patched/client/civclient.c
--- freeciv-cvs/client/civclient.c	2003-06-07 19:58:20.000000000 +0100
+++ freeciv-patched/client/civclient.c	2003-06-30 12:33:10.000000000 +0100
@@ -365,6 +365,15 @@
     handle_ruleset_unit((struct packet_ruleset_unit *)packet);
     break;
     
+  case PACKET_RULESET_MODIFIER_TYPE:
+    handle_ruleset_modifier_type(
+	(struct packet_ruleset_modifier_type *)packet);
+    break;
+    
+  case PACKET_RULESET_MODIFIER:
+    handle_ruleset_modifier((struct packet_ruleset_modifier *)packet);
+    break;
+    
   case PACKET_RULESET_TECH:
     handle_ruleset_tech((struct packet_ruleset_tech *)packet);
     break;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk/menu.c freeciv-patched/client/gui-gtk/menu.c
--- freeciv-cvs/client/gui-gtk/menu.c	2003-06-26 20:13:14.000000000 +0100
+++ freeciv-patched/client/gui-gtk/menu.c	2003-06-30 12:33:10.000000000 +0100
@@ -79,6 +79,8 @@
   MENU_KINGDOM_TAX_RATE,
   MENU_KINGDOM_FIND_CITY,
   MENU_KINGDOM_WORKLISTS,
+  MENU_KINGDOM_WORKSHOP,
+  MENU_KINGDOM_ENGINEERING,
   MENU_KINGDOM_REVOLUTION,
 
   MENU_VIEW_SHOW_MAP_GRID,
@@ -211,6 +213,12 @@
   case MENU_KINGDOM_WORKLISTS:
     popup_worklists_report(game.player_ptr);
     break;
+  case MENU_KINGDOM_WORKSHOP:
+    popup_workshop_dialog();
+    break;
+  case MENU_KINGDOM_ENGINEERING:
+    popup_engineering_dialog();
+    break;
   case MENU_KINGDOM_REVOLUTION:
     popup_revolution_dialog();
     break;
@@ -598,6 +606,12 @@
 	kingdom_menu_callback,	MENU_KINGDOM_WORKLISTS					},
   { "/" N_("Kingdom") "/sep2",				NULL,
 	NULL,			0,					"<Separator>"	},
+  { "/" N_("Kingdom") "/" N_("Design _Workshop"),	NULL,
+	kingdom_menu_callback,	MENU_KINGDOM_WORKSHOP					},
+  { "/" N_("Kingdom") "/" N_("Social _Engineering"),	NULL,
+	kingdom_menu_callback,	MENU_KINGDOM_ENGINEERING					},
+  { "/" N_("Kingdom") "/sep3",				NULL,
+	NULL,			0,					"<Separator>"	},
   { "/" N_("Kingdom") "/" N_("_Government"),  NULL,
 	NULL,           0,                  "<Branch>"    },
   { "/" N_("Kingdom") "/" N_("_Government") "/" N_("_Revolution!"),
@@ -1033,6 +1047,10 @@
     }
 
     menus_set_sensitive("<main>/_Reports", TRUE);
+    menus_set_sensitive("<main>/_Kingdom/Design _Workshop",
+			game.num_unit_modifier_types > 0);
+    menus_set_sensitive("<main>/_Kingdom/Social _Engineering",
+			game.num_gov_modifier_types > 0);
     menus_set_sensitive("<main>/_Kingdom", TRUE);
     menus_set_sensitive("<main>/_View", TRUE);
     menus_set_sensitive("<main>/_Orders", can_client_issue_orders());
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-gtk-2.0/menu.c freeciv-patched/client/gui-gtk-2.0/menu.c
--- freeciv-cvs/client/gui-gtk-2.0/menu.c	2003-06-26 20:13:14.000000000 +0100
+++ freeciv-patched/client/gui-gtk-2.0/menu.c	2003-06-30 12:33:10.000000000 +0100
@@ -80,6 +80,8 @@
   MENU_KINGDOM_TAX_RATE,
   MENU_KINGDOM_FIND_CITY,
   MENU_KINGDOM_WORKLISTS,
+  MENU_KINGDOM_WORKSHOP,
+  MENU_KINGDOM_ENGINEERING,
   MENU_KINGDOM_REVOLUTION,
 
   MENU_VIEW_SHOW_MAP_GRID,
@@ -212,6 +214,12 @@
   case MENU_KINGDOM_WORKLISTS:
     popup_worklists_report();
     break;
+  case MENU_KINGDOM_WORKSHOP:
+    popup_workshop_dialog();
+    break;
+  case MENU_KINGDOM_ENGINEERING:
+    popup_engineering_dialog();
+    break;
   case MENU_KINGDOM_REVOLUTION:
     popup_revolution_dialog();
     break;
@@ -597,6 +605,12 @@
 	kingdom_menu_callback,	MENU_KINGDOM_WORKLISTS					},
   { "/" N_("Kingdom") "/sep2",				NULL,
 	NULL,			0,					"<Separator>"	},
+  { "/" N_("Kingdom") "/" N_("Design _Workshop"),	NULL,
+	kingdom_menu_callback,	MENU_KINGDOM_WORKSHOP					},
+  { "/" N_("Kingdom") "/" N_("Social _Engineering"),	NULL,
+	kingdom_menu_callback,	MENU_KINGDOM_ENGINEERING					},
+  { "/" N_("Kingdom") "/sep3",				NULL,
+	NULL,			0,					"<Separator>"	},
   { "/" N_("_Kingdom") "/" N_("_Government"),           NULL,
 	NULL,			0,					"<Branch>"	},
   { "/" N_("Kingdom") "/" N_("_Government") "/" N_("_Revolution"),
@@ -1052,6 +1066,10 @@
     }
 
     menus_set_sensitive("<main>/_Reports", TRUE);
+    menus_set_sensitive("<main>/_Kingdom/Design _Workshop",
+			game.num_unit_modifier_types > 0);
+    menus_set_sensitive("<main>/_Kingdom/Social _Engineering",
+			game.num_gov_modifier_types > 0);
     menus_set_sensitive("<main>/_Kingdom", TRUE);
     menus_set_sensitive("<main>/_View", TRUE);
     menus_set_sensitive("<main>/_Orders", can_client_issue_orders());
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/include/dialogs_g.h freeciv-patched/client/include/dialogs_g.h
--- freeciv-cvs/client/include/dialogs_g.h	2002-11-29 12:25:10.000000000 +0000
+++ freeciv-patched/client/include/dialogs_g.h	2003-06-30 12:33:10.000000000 +0100
@@ -15,10 +15,9 @@
 
 #include "shared.h"		/* bool type */
 #include "terrain.h"		/* enum tile_special_type */
+#include "unittype.h"		/* Unit_Type_id type */
 
 struct tile;
-struct unit;
-struct city;
 struct packet_nations_used;
 
 void popup_notify_goto_dialog(char *headline, char *lines, int x, int y);
@@ -33,6 +32,9 @@
 
 void popup_revolution_dialog(void);
 void popup_government_dialog(void);
+void popup_workshop_dialog(void);
+void popup_engineering_dialog(void);
+void workshop_dialog_update(Unit_Type_id id);
 void popup_caravan_dialog(struct unit *punit,
 			  struct city *phomecity, struct city *pdestcity);
 bool caravan_dialog_is_open(void);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/packhand.c freeciv-patched/client/packhand.c
--- freeciv-cvs/client/packhand.c	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/client/packhand.c	2003-06-30 12:33:10.000000000 +0100
@@ -1945,6 +1945,25 @@
   game.num_impr_types = packet->num_impr_types;
   game.num_tech_types = packet->num_tech_types;
 
+  game.num_unit_modifier_types = packet->num_unit_modifier_types;
+  game.num_unit_modifiers = packet->num_unit_modifiers;
+  game.num_gov_modifier_types = packet->num_gov_modifier_types;
+  game.num_gov_modifiers = packet->num_gov_modifiers;
+
+  if (game.num_unit_modifiers > 0) {
+    unit_modifiers = fc_calloc(game.num_unit_modifiers,
+			       sizeof(struct modifier));
+  } else {
+    unit_modifiers = NULL;
+  }
+
+  if (game.num_gov_modifiers > 0) {
+    gov_modifiers = fc_calloc(game.num_gov_modifiers,
+			      sizeof(struct modifier));
+  } else {
+    gov_modifiers = NULL;
+  }
+
   governments_alloc(packet->government_count);
 
   nations_alloc(packet->nation_count);
@@ -1965,12 +1984,17 @@
 void handle_ruleset_unit(struct packet_ruleset_unit *p)
 {
   struct unit_type *u;
+  int i;
 
-  if(p->id < 0 || p->id >= game.num_unit_types || p->id >= U_LAST) {
+  if(p->id < 0 || p->id >= U_LAST) {
     freelog(LOG_ERROR, "Received bad unit_type id %d in handle_ruleset_unit()",
 	    p->id);
     return;
   }
+  if (p->id >= game.num_unit_types) {
+    freelog(LOG_NORMAL, "Number of unit types increased to %d", p->id + 1);
+    game.num_unit_types = p->id + 1;
+  }
   u = get_unit_type(p->id);
 
   sz_strlcpy(u->name, p->name);
@@ -2006,9 +2030,72 @@
   u->paratroopers_mr_sub = p->paratroopers_mr_sub;
   u->effect             = p->effect;  /* pointer assignment */
 
+  u->basetype         = p->basetype;
+  for (i = 0; i < MAX_MODS; ++i) {
+    u->modifiers[i]   = p->modifiers[i];
+  }
+
   u->helptext = p->helptext;	/* pointer assignment */
 
   tilespec_setup_unit_type(p->id);
+
+  workshop_dialog_update(p->id);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+void handle_ruleset_modifier_type(
+    struct packet_ruleset_modifier_type *p)
+{
+  struct modifier_type *u;
+  int max_mod;
+
+  max_mod = (p->is_gov ? game.num_gov_modifier_types
+      		       : game.num_unit_modifier_types);
+
+  if (p->id < 0 || p->id >= max_mod) {
+    freelog(LOG_ERROR, "Received bad modifier type id %d in "
+                     "handle_ruleset_modifier_type()", p->id);
+    return;
+  }
+  if (p->is_gov) {
+    u = &gov_modifier_types[p->id];
+  } else {
+    u = &unit_modifier_types[p->id];
+  }
+  sz_strlcpy(u->name, p->name);
+  u->id = p->basetype;
+  u->tech_requirement = p->tech_requirement;
+  u->must_use = p->must_use;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+void handle_ruleset_modifier(struct packet_ruleset_modifier *p)
+{
+  struct modifier *u;
+  int max_mod;
+
+  max_mod = (p->is_gov ? game.num_gov_modifiers
+      		       : game.num_unit_modifiers);
+
+  if (p->id < 0 || p->id >= max_mod) {
+    freelog(LOG_ERROR,
+      "Received bad modifier id %d in handle_ruleset_modifier()",
+      p->id);
+    return;
+  }
+  if (p->is_gov) {
+    u = &gov_modifiers[p->id];
+  } else {
+    u = &unit_modifiers[p->id];
+  }
+  sz_strlcpy(u->name, p->name);
+  u->type = p->type;
+  u->tech_requirement = p->tech_requirement;
+  u->effect = p->effect;	/* pointer assignment */
 }
 
 /**************************************************************************
@@ -2211,13 +2298,21 @@
 void handle_ruleset_government(struct packet_ruleset_government *p)
 {
   struct government *gov;
+  int i;
 
-  if (p->id < 0 || p->id >= game.government_count) {
+  if (p->id < 0 || p->id >= G_MAGIC) {
     freelog(LOG_ERROR,
 	    "Received bad government id %d in handle_ruleset_government",
 	    p->id);
     return;
   }
+  if (p->id >= game.government_count) {
+    freelog(LOG_NORMAL, "Number of gov types increased to %d", p->id + 1);
+    game.government_count = p->id + 1;
+    governments = (struct government *)fc_realloc(governments,
+        					  game.government_count
+                                                  * sizeof(struct government));
+  }
   gov = &governments[p->id];
 
   gov->index             = p->id;
@@ -2230,6 +2325,11 @@
   gov->empire_size_mod   = p->empire_size_mod;
   gov->empire_size_inc   = p->empire_size_inc;
   gov->rapture_size      = p->rapture_size;
+  gov->basetype		 = p->basetype;
+
+  for (i = 0; i < MAX_MODS; ++i) {
+    gov->modifiers[i]    = p->modifiers[i];
+  }
   
   gov->unit_happy_cost_factor  = p->unit_happy_cost_factor;
   gov->unit_shield_cost_factor = p->unit_shield_cost_factor;
@@ -2286,6 +2386,13 @@
   gov->helptext = p->helptext;	/* pointer assignment */
   
   tilespec_setup_government(p->id);
+
+  /* If we're getting governments re-sent after the game has started,
+   * then this generally means a player has changed government, and
+   * thus an effect update is needed. */
+  if(get_client_state()==CLIENT_GAME_RUNNING_STATE) {
+    update_all_effects();
+  }
 }
 void handle_ruleset_government_ruler_title
   (struct packet_ruleset_government_ruler_title *p)
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/packhand.h freeciv-patched/client/packhand.h
--- freeciv-cvs/client/packhand.h	2003-06-27 15:51:10.000000000 +0100
+++ freeciv-patched/client/packhand.h	2003-06-30 12:33:10.000000000 +0100
@@ -47,6 +47,9 @@
 void handle_remove_player(struct packet_generic_integer *packet);
 void handle_ruleset_control(struct packet_ruleset_control *packet);
 void handle_ruleset_unit(struct packet_ruleset_unit *p);
+void handle_ruleset_modifier_type(
+    struct packet_ruleset_modifier_type *p);
+void handle_ruleset_modifier(struct packet_ruleset_modifier *p);
 void handle_ruleset_tech(struct packet_ruleset_tech *p);
 void handle_ruleset_building(struct packet_ruleset_building *p);
 void handle_ruleset_terrain(struct packet_ruleset_terrain *p);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/capstr.c freeciv-patched/common/capstr.c
--- freeciv-cvs/common/capstr.c	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/capstr.c	2003-06-30 12:33:33.000000000 +0100
@@ -78,7 +78,7 @@
                    "city_struct_minor_cleanup obsolete_last class_legend " \
                    "+impr_req +waste +fastfocus +continent +small_dipl " \
                    "+no_nation_selected +diplomacy +no_extra_tiles " \
-                   "+diplomacy2 +citizens_style +root_tech impr_gen"
+                   "+diplomacy2 +citizens_style +root_tech impr_gen compounds"
 
 /* "+1.14.0" is protocol for 1.14.0 release.
  *
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/game.h freeciv-patched/common/game.h
--- freeciv-cvs/common/game.h	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/game.h	2003-06-30 12:33:10.000000000 +0100
@@ -152,6 +152,10 @@
   int num_unit_types;
   int num_impr_types;
   int num_tech_types;  /* including A_NONE */
+  int num_unit_modifier_types;
+  int num_unit_modifiers;
+  int num_gov_modifier_types;
+  int num_gov_modifiers;
 
   int government_count;
   int default_government;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/government.c freeciv-patched/common/government.c
--- freeciv-cvs/common/government.c	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/government.c	2003-06-30 12:33:10.000000000 +0100
@@ -19,9 +19,11 @@
 #include <stdlib.h>
 #include <string.h>
 
+#include "fcintl.h"
 #include "game.h"
 #include "log.h"
 #include "mem.h"
+#include "member.h"
 #include "player.h"
 #include "shared.h"
 #include "support.h"
@@ -59,6 +61,8 @@
  */
 
 struct government *governments = NULL;
+struct modifier_type gov_modifier_types[MAX_MODS];
+struct modifier *gov_modifiers = NULL;
 
 struct ai_gov_tech_hint ai_gov_tech_hints[MAX_NUM_TECH_LIST];
 
@@ -66,7 +70,7 @@
   "(unused)", "Revolution_When_Unhappy", "Has_Senate",
   "Unbribable", "Inspires_Partisans", "Rapture_City_Growth",
   "Fanatic_Troops", "No_Unhappy_Citizens", "Convert_Tithes_To_Money",
-  "Reduced_Research"
+  "Reduced_Research", "CanModify"
 };
 static const char *hint_names[] = {
   "Is_Nice", "Favors_Growth"
@@ -143,6 +147,25 @@
   return NULL;
 }
 
+int find_gov_modifier_by_name(const char *s)
+{
+  return find_modifier_by_name(s, gov_modifiers, game.num_gov_modifiers);
+}
+
+bool government_has_modifier(struct government *gov, int govmod)
+{
+  if (gov && gov->basetype != G_MAGIC) {
+    int i;
+
+    for (i = 0; i < game.num_gov_modifier_types; ++i) {
+      if (gov->modifiers[i] == govmod) {
+	return TRUE;
+      }
+    }
+  }
+  return FALSE;
+}
+
 /***************************************************************
 ...
 ***************************************************************/
@@ -319,3 +342,226 @@
   governments = NULL;
   game.government_count = 0;
 }
+
+static void set_city_cost(void *structpt, unsigned long offset,
+    			  const size_t size, const char *val)
+{
+  int *member = FC_STRUCT_MEMBER_P(int, structpt, offset);
+
+  if (mystrcasecmp(val, "City_Size") == 0) {
+    *member = G_CITY_SIZE_FREE;
+  } else {
+    *member = atoi(val);
+  }
+}
+
+static void read_city_cost(void *structpt, unsigned long offset,
+    			   const size_t size, struct section_file *file,
+			   const char *sec, const char *membername)
+{
+  char *sval;
+
+  sval = secfile_lookup_str(file, "%s.%s", sec, membername);
+  set_city_cost(structpt, offset, size, sval);
+}
+
+#define FC_GOV_OFFSET(member) \
+    FC_STRUCT_OFFSET(struct government, member)
+#define FC_GOV_SIZE(member) \
+    FC_MEMBER_SIZE(struct government, member)
+
+static struct members gov_members[] = {
+  { "name",
+    FC_GOV_OFFSET(name_orig),
+    FC_GOV_SIZE(name_orig),
+    NULL, set_string, get_string, binary_string },
+  { "graphic", FC_GOV_OFFSET(graphic_str), FC_GOV_SIZE(graphic_str),
+    read_string, set_string, get_string, binary_string },
+  { "graphic_alt", FC_GOV_OFFSET(graphic_alt), FC_GOV_SIZE(graphic_alt),
+    read_string, set_string, get_string, binary_string },
+  { "tech_req", FC_GOV_OFFSET(required_tech),
+    FC_GOV_SIZE(required_tech),
+    NULL, set_tech, get_tech, NULL },
+  { "martial_law_max", FC_GOV_OFFSET(martial_law_max),
+    FC_GOV_SIZE(martial_law_max),
+    read_int, set_int, get_int, binary_int },
+  { "martial_law_per", FC_GOV_OFFSET(martial_law_per),
+    FC_GOV_SIZE(martial_law_per),
+    read_int, set_int, get_int, binary_int },
+  { "max_single_rate", FC_GOV_OFFSET(max_rate), FC_GOV_SIZE(max_rate),
+    read_int, set_int, get_int, binary_int },
+  { "civil_war_chance", FC_GOV_OFFSET(civil_war), FC_GOV_SIZE(civil_war),
+    read_int, set_int, get_int, binary_int },
+  { "empire_size_mod", FC_GOV_OFFSET(empire_size_mod),
+    FC_GOV_SIZE(empire_size_mod),
+    read_int, set_int, get_int, binary_int },
+  { "empire_size_inc", FC_GOV_OFFSET(empire_size_inc),
+    FC_GOV_SIZE(empire_size_inc),
+    read_int, set_int, get_int, binary_int },
+  { "rapture_size", FC_GOV_OFFSET(rapture_size), FC_GOV_SIZE(rapture_size),
+    read_int, set_int, get_int, binary_int },
+  { "unit_free_unhappy", FC_GOV_OFFSET(free_happy),
+    FC_GOV_SIZE(free_happy),
+    read_city_cost, set_city_cost, get_int, binary_int },
+  { "unit_free_shield", FC_GOV_OFFSET(free_shield),
+    FC_GOV_SIZE(free_shield),
+    read_city_cost, set_city_cost, get_int, binary_int },
+  { "unit_free_food", FC_GOV_OFFSET(free_food),
+    FC_GOV_SIZE(free_food),
+    read_city_cost, set_city_cost, get_int, binary_int },
+  { "unit_free_gold", FC_GOV_OFFSET(free_gold),
+    FC_GOV_SIZE(free_gold),
+    read_city_cost, set_city_cost, get_int, binary_int },
+  { "unit_unhappy_factor", FC_GOV_OFFSET(unit_happy_cost_factor),
+    FC_GOV_SIZE(unit_happy_cost_factor),
+    read_int, set_int, get_int, binary_int },
+  { "unit_shield_factor", FC_GOV_OFFSET(unit_shield_cost_factor),
+    FC_GOV_SIZE(unit_shield_cost_factor),
+    read_int, set_int, get_int, binary_int },
+  { "unit_food_factor", FC_GOV_OFFSET(unit_food_cost_factor),
+    FC_GOV_SIZE(unit_food_cost_factor),
+    read_int, set_int, get_int, binary_int },
+  { "unit_gold_factor", FC_GOV_OFFSET(unit_gold_cost_factor),
+    FC_GOV_SIZE(unit_gold_cost_factor),
+    read_int, set_int, get_int, binary_int },
+  { "corruption_level", FC_GOV_OFFSET(corruption_level),
+    FC_GOV_SIZE(corruption_level),
+    read_int, set_int, get_int, binary_int },
+  { "corruption_modifier", FC_GOV_OFFSET(corruption_modifier),
+    FC_GOV_SIZE(corruption_modifier),
+    read_int, set_int, get_int, binary_int },
+  { "corruption_fixed_distance", FC_GOV_OFFSET(fixed_corruption_distance),
+    FC_GOV_SIZE(fixed_corruption_distance),
+    read_int, set_int, get_int, binary_int },
+  { "corruption_distance_factor", FC_GOV_OFFSET(corruption_distance_factor),
+    FC_GOV_SIZE(corruption_distance_factor),
+    read_int, set_int, get_int, binary_int },
+  { "corruption_extra_distance", FC_GOV_OFFSET(extra_corruption_distance),
+    FC_GOV_SIZE(extra_corruption_distance),
+    read_int, set_int, get_int, binary_int },
+  { "trade_penalty", FC_GOV_OFFSET(trade_before_penalty),
+    FC_GOV_SIZE(trade_before_penalty),
+    read_int, set_int, get_int, binary_int },
+  { "shield_penalty", FC_GOV_OFFSET(shields_before_penalty),
+    FC_GOV_SIZE(shields_before_penalty),
+    read_int, set_int, get_int, binary_int },
+  { "food_penalty", FC_GOV_OFFSET(food_before_penalty),
+    FC_GOV_SIZE(food_before_penalty),
+    read_int, set_int, get_int, binary_int },
+  { "celeb_trade_penalty", FC_GOV_OFFSET(celeb_trade_before_penalty),
+    FC_GOV_SIZE(celeb_trade_before_penalty),
+    read_int, set_int, get_int, binary_int },
+  { "celeb_shield_penalty", FC_GOV_OFFSET(celeb_shields_before_penalty),
+    FC_GOV_SIZE(celeb_shields_before_penalty),
+    read_int, set_int, get_int, binary_int },
+  { "celeb_food_penalty", FC_GOV_OFFSET(celeb_food_before_penalty),
+    FC_GOV_SIZE(celeb_food_before_penalty),
+    read_int, set_int, get_int, binary_int },
+  { "trade_bonus", FC_GOV_OFFSET(trade_bonus),
+    FC_GOV_SIZE(trade_bonus),
+    read_int, set_int, get_int, binary_int },
+  { "shield_bonus", FC_GOV_OFFSET(shield_bonus),
+    FC_GOV_SIZE(shield_bonus),
+    read_int, set_int, get_int, binary_int },
+  { "food_bonus", FC_GOV_OFFSET(food_bonus),
+    FC_GOV_SIZE(food_bonus),
+    read_int, set_int, get_int, binary_int },
+  { "celeb_trade_bonus", FC_GOV_OFFSET(celeb_trade_bonus),
+    FC_GOV_SIZE(celeb_trade_bonus),
+    read_int, set_int, get_int, binary_int },
+  { "celeb_shield_bonus", FC_GOV_OFFSET(celeb_shield_bonus),
+    FC_GOV_SIZE(celeb_shield_bonus),
+    read_int, set_int, get_int, binary_int },
+  { "celeb_food_bonus", FC_GOV_OFFSET(celeb_food_bonus),
+    FC_GOV_SIZE(celeb_food_bonus),
+    read_int, set_int, get_int, binary_int },
+  { NULL, 0, 0, NULL, NULL, NULL, NULL }
+};
+
+void gov_copy_members(struct government *dest, const struct government *src)
+{
+  copy_members((void *)dest, (const void *)src, gov_members);
+}
+
+void gov_read_members(struct government *gov, struct section_file *file,
+    		      const char *sec)
+{
+  read_members((void *)gov, gov_members, file, sec);
+}
+
+static void ApplyGovModAction(struct government *gov, char *action)
+{
+  apply_action((void *)gov, gov_members, action);
+}
+
+/***************************************************************
+...
+***************************************************************/
+int form_compound_gov(const struct player *pplayer, const char *name,
+    		      const int basetype, const int modifiers[MAX_MODS])
+{
+  struct government *gov = NULL, *base;
+  struct modifier *mod;
+  int id = -1, i;
+
+  if (pplayer) {
+    id = pplayer->government;
+    gov = get_gov_pplayer(pplayer);
+  }
+  if (!pplayer || gov->basetype == G_MAGIC) {
+    id = game.government_count++;
+    if (id >= G_MAGIC) {
+      freelog(LOG_FATAL, "form_compound_gov: out of government types");
+      exit(EXIT_FAILURE);
+    }
+
+    governments = (struct government *)fc_realloc(governments,
+						  game.government_count
+						  * sizeof(struct government));
+    gov = &governments[id];
+    gov->helptext = NULL;
+    gov->index = id;
+  } else if (pplayer) {
+    government_free(gov);
+  }
+  base = &governments[basetype];
+  gov_copy_members(gov, base);
+  gov->effect = NULL;
+  append_effects(&gov->effect, base->effect);
+  gov->flags = base->flags;
+  gov->hints = base->hints;
+  gov->subgoal = base->subgoal;
+  gov->num_ruler_titles = base->num_ruler_titles;
+  gov->ruler_titles = fc_calloc(gov->num_ruler_titles,
+      				sizeof(struct ruler_title));
+  for (i = 0; i < gov->num_ruler_titles; ++i) {
+    struct ruler_title *fromtitle = &(base->ruler_titles[i]);
+    struct ruler_title *totitle = &(gov->ruler_titles[i]);
+
+    totitle->nation = fromtitle->nation;
+    sz_strlcpy(totitle->male_title, fromtitle->male_title);
+    sz_strlcpy(totitle->female_title, fromtitle->female_title);
+  }
+  gov->basetype = basetype;
+  for (i = 0; i < game.num_gov_modifier_types; ++i) {
+    gov->modifiers[i] = modifiers[i];
+  }
+  gov->required_tech = A_NONE;
+  gov->name_orig[0] = '\0';
+  for (i = 0; i < game.num_gov_modifier_types; ++i) {
+    if (gov->modifiers[i] < U_LAST) {
+      mod = &gov_modifiers[gov->modifiers[i]];
+      ApplyGovModAction(gov, mod->action);
+    }
+  }
+  for (i = 0; i < game.num_gov_modifier_types; ++i) {
+    if (gov->modifiers[i] < U_LAST) {
+      mod = &gov_modifiers[gov->modifiers[i]];
+      ApplyGovModAction(gov, mod->final_action);
+      append_effects(&gov->effect, mod->effect);
+    }
+  }
+  sz_strlcpy(gov->name, _(gov->name_orig));
+
+  return id;
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/government.h freeciv-patched/common/government.h
--- freeciv-cvs/common/government.h	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/government.h	2003-06-30 12:33:10.000000000 +0100
@@ -14,11 +14,13 @@
 #define FC__GOVERNMENT_H
 
 #include "shared.h"
+#include "modifier.h"
 
 struct city;
 struct player;
 struct Sprite;			/* opaque; client-gui specific */
 struct impr_effect;
+struct section_file;
 
 #define G_MAGIC (127)		/* magic constant, used as flag value */
 
@@ -39,6 +41,7 @@
   G_CONVERT_TITHES_TO_MONEY,    /* tithes to money, needed by fundamentalism */
   G_REDUCED_RESEARCH,           /* penalty for research, needed by
 				   fundamentalism */
+  G_CAN_MODIFY,			/* can apply government modifiers */
   G_LAST_FLAG
 };
 #define G_FIRST_FLAG G_BUILD_VETERAN_DIPLOMAT
@@ -156,6 +159,9 @@
   struct Sprite *sprite;
 
   struct impr_effect *effect; /* list; .type==EFT_LAST terminated */
+
+  int basetype;		/* if !G_MAGIC, government modifiers are applied */
+  int modifiers[MAX_MODS];
   
   char *helptext;
 };
@@ -172,6 +178,8 @@
 };
 
 extern struct government *governments;
+extern struct modifier_type gov_modifier_types[MAX_MODS];
+extern struct modifier *gov_modifiers;
 
 extern struct ai_gov_tech_hint ai_gov_tech_hints[MAX_NUM_TECH_LIST];
 /* like game.rtech lists, A_LAST terminated (for .tech)
@@ -182,6 +190,8 @@
 struct government *get_gov_pcity(struct city *pcity);
 
 struct government *find_government_by_name(const char *name);
+int find_gov_modifier_by_name(const char *s);
+bool government_has_modifier(struct government *gov, int govmod);
 
 enum government_flag_id government_flag_from_str(const char *s);
 bool government_has_flag(const struct government *gov,
@@ -201,5 +211,10 @@
                      const char *male, const char *female);
 void governments_alloc(int num);
 void governments_free(void);
+void gov_copy_members(struct government *dest, const struct government *src);
+void gov_read_members(struct government *gov, struct section_file *file,
+		      const char *sec);
+int form_compound_gov(const struct player *pplayer, const char *name,
+    		      const int basetype, const int modifiers[MAX_MODS]);
 
 #endif  /* FC__GOVERNMENT_H */
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/improvement.c freeciv-patched/common/improvement.c
--- freeciv-cvs/common/improvement.c	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/improvement.c	2003-06-30 12:33:10.000000000 +0100
@@ -1035,6 +1035,12 @@
     freelog(LOG_DEBUG, "Effect requires a government");
     return FALSE;
   }
+  if (imeff->cond_govmod != game.num_gov_modifiers && pplayer
+      && !government_has_modifier(get_gov_pplayer(pplayer),
+				  imeff->cond_govmod)) {
+    freelog(LOG_DEBUG, "Effect requires a government modifier");
+    return FALSE;
+  }
   if (pplayer && get_invention(pplayer, imeff->cond_adv) != TECH_KNOWN) {
     freelog(LOG_DEBUG, "Effect requires a future tech");
     return FALSE;
@@ -1457,3 +1463,30 @@
     }
   }
 }
+
+void append_effects(struct impr_effect **dest, struct impr_effect *src)
+{
+  int numsrc = 0, numdest = 0, numeff;
+  struct impr_effect *eff;
+
+  for (eff = *dest; eff && eff->type != EFT_LAST; ++eff) {
+    numdest++;
+  }
+  for (eff = src; eff && eff->type != EFT_LAST; ++eff) {
+    numsrc++;
+  }
+  numeff = numdest + numsrc;
+
+  if (numeff > MAX_EFFECTS) {
+    freelog(LOG_FATAL, "MAX_EFFECTS exceeded");
+    exit(EXIT_FAILURE);
+  }
+
+  if (numsrc) {
+    *dest = fc_realloc(*dest, (numeff + 1) * sizeof(struct impr_effect));
+    memcpy(*dest + numdest, src, (numsrc + 1) * sizeof(struct impr_effect));
+  } else if (!*dest) {
+    *dest = fc_malloc(sizeof(struct impr_effect));
+    (*dest)->type = EFT_LAST;
+  }
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/improvement.h freeciv-patched/common/improvement.h
--- freeciv-cvs/common/improvement.h	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/improvement.h	2003-06-30 12:33:10.000000000 +0100
@@ -201,6 +201,7 @@
 					 * center tile */
   Impr_Type_id cond_bldg;	   /* B_LAST = unconditional */
   int cond_gov;			   /* game.government_count = unconditional */
+  int cond_govmod;		   /* game.num_gov_modifiers = unconditional */
   Tech_Type_id cond_adv;	   /* A_NONE = unconditional; A_LAST = never */
   enum effect_type cond_eff;	   /* EFT_LAST = unconditional */
   Unit_Class_id aff_unit;	   /* UCL_LAST = all */
@@ -440,6 +441,7 @@
 struct ceff_vector *get_eff_city(struct city *pcity);
 void remove_global_effects(Impr_Type_id impr, struct player *pplayer);
 void add_global_effects(Impr_Type_id impr, struct player *pplayer);
+void append_effects(struct impr_effect **dest, struct impr_effect *src);
 
 void allot_island_improvs(void);
 void improvements_update_obsolete(void);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/Makefile.am freeciv-patched/common/Makefile.am
--- freeciv-cvs/common/Makefile.am	2003-06-07 19:58:26.000000000 +0100
+++ freeciv-patched/common/Makefile.am	2003-06-30 12:33:10.000000000 +0100
@@ -63,6 +63,10 @@
 		pqueue.h	\
 		mem.c           \
 		mem.h		\
+		member.c        \
+		member.h	\
+		modifier.c	\
+		modifier.h	\
 		rand.c		\
 		rand.h		\
 		registry.c	\
